`distrib.plot` <-
function(data, labels=NULL, plot=TRUE, ...){
  ##Have to add the name for apply function
  data2<-data.frame(matrix(NA, ncol=ncol(data)+1, nrow=nrow(data)))
  data2[,1]<-rownames(data)
  data2[,2:ncol(data2)]<-data
  colnames(data2)<-c("probe", colnames(data))
  data<-data2
  rm(data2)

  
  ##For each variable
  out<-apply(data,1,exp_grp<-function(x){

    x11()
    id<-x[1]
    x<-as.numeric(x[-1])
 
   
    if (!is.null(labels)){


      col<-rainbow(n=length(unique(labels)))
      cpt<-1
      
      maxcounts<-NULL
      
      for (i in unique(labels)){
        x.tmp<-x[which(labels==i)]
        
        h.tmp <- hist(x.tmp, breaks=20, plot=FALSE)
 
        if(cpt==1){
          plot(h.tmp, col=col[cpt], cex.axis=0.7, cex.lab=0.7, cex.main=0.8,main = paste("Expression level of",id),xlab='Expression Level',ylab='Counts', ...)
        }
        else{
          plot(h.tmp, col=col[cpt], add=TRUE, ...)
        }
        
        if(is.null(maxcounts)){
          maxcounts <- max(h.tmp$counts)
        }else{
          maxcounts <- max(c(maxcounts, h.tmp$counts))
        }
     
        cpt<-cpt+1
      }
      
      print (maxcounts)
      legend(x=min(x),y=maxcounts,unique(labels),fill=col, bty="n", cex=0.7, text.col="gray50", ...)
    }
    else{
  
      h <- hist(as.numeric(x), breaks=40, plot=FALSE)
      plot(h, cex.lab=0.7,  col="blue",cex.axis=0.7,cex.main=0.8,main = paste("Expression level of",id),xlab='Expression Level',ylab='Counts', ...)
      
    }
  })
  return(out)
}

