`runIndTest` <-
function(data,labels,gene.names=NULL, plot=TRUE){

  if (is.null(gene.names)){
    if (is.null(rownames(data))){
      gene.names=1:nrow(data)
    }
    else{
      gene.names=rownames(data)
    }
  }
  
  if (is.vector(data)){
    grp1<-matrix(data[which(labels==0)], nrow=1)
    grp2<-matrix(data[which(labels==1)], nrow=1)
    cpt<-1
  }
  else{    
    grp1<-data[,which(labels==0)]
    grp2<-data[,which(labels==1)]
    cpt<-nrow(data)
  }
  
  out<-as.data.frame(matrix(NA, ncol=3, nrow=cpt))
  for(i in 1:cpt){
    
    
    testnorm<-shapiro.test(c(grp1[i,],grp2[i,]))
    
    if(testnorm$p.value<0.05){## no Normal
      test<-"Wilcoxon"
      testmoyenne<-wilcox.test(grp1[i,],grp2[i,])
      }else{
        testvariance<-var.test(grp1[i,],grp2[i,])
        if(testvariance$p.value<0.05){## no equal var
	  test<-"Welch"
          testmoyenne<-t.test(grp1[i,],grp2[i,],var.equal=FALSE)          
        }else{
	  test<-"Student"
          testmoyenne<-t.test(grp1[i,],grp2[i,],var.equal=TRUE)
        }
      }
    pval<-round(testmoyenne$p.value,3)
    
    if (plot){
      x11()
      hg1<-hist(grp1[i,], plot=FALSE)
      hg2<-hist(grp2[i,], plot=FALSE)

      par(mfrow=c(1,3))
      plot(hg1, main="Group1")
      points(density(grp1[i,],na.rm=TRUE),type="l",lwd=1,col="red")
      boxplot(grp1[i,],grp2[i,],main=gene.names[i],names=c("group1","group2"),col=c("light blue","#2896C8"))
      plot(hg2, main="Group2") 
      points(density(grp2[i,],na.rm=TRUE),type="l",lwd=1,col="red")
    }
    out[i,]<-c(gene.names[i],test,pval)
  }
  
  
  return(out)
}

