`test.LC` <-
function(C, X, Y) {
### test sur plusieurs combinaisons lineaires
## C:      vecteur ou matrice des combinaisons lineaires a tester (matrice: une ligne = une CL)
## X:      matrice de design, obtenue a partir du modele lineaire
## Y:      vecteur ou matrice de reponse (matrice: une colonne = un gene)

    r <- ncol(X)
    n <- nrow(X)
    if (class(C)!="matrix") C=t(as.matrix(C))

    invX <- solve(t(X) %*% X)
    theta <- invX %*% t(X) %*% Y
    Y.pred <- X %*% theta
    DEN <- (Y - Y.pred)^2
    sigma2 <- colSums(DEN)/(n - r)
    phi <- C %*% theta
    F <- phi^2/(as.matrix(rowSums((C %*% invX) * C)) %*% as.matrix(t(sigma2)))
    pvalue <- 1 - pf(F, 1, n - r)
    return(list(F = F, pvalue = pvalue, Y.pred = Y.pred, resid = Y-Y.pred, sigma2 = sigma2, theta = theta))
}

