\name{htmlresult}
\alias{htmlresult}

\title{Html report from the result of a call to 'hyperGTest'}
\description{
  Create a html report from the result of a call to 'hyperGTest'
}
\usage{
htmlresult(hgOver, filename, app = FALSE, categorySize = 1, pvalue=0.05)
}

\arguments{
  \item{hgOver}{result from a call to 'hyperGTest'}
  \item{filename}{file name with path for html result}
  \item{app}{if TRUE, overwrite the pre-existing html report file, by default FALSE}
  \item{categorySize}{an integer, minimum size for category, by default  =1}
  \item{pvalue}{the pvalue threshold for significance, default =0.05}
}

\value{
  An html report with the result from a call to 'hyperGTest'

  Id, pvalue, Odd Ratio, Expected Count, Count, Size and Term are returned 
}

\author{EMA group}

\seealso{\code{\link{hyperGTest}},\code{\link{runHyperGO}}}
\examples{
  data(marty)
  ## Probe list
  probeList <- rownames(marty)[1:50]

  ## Create an instance of a subclass of 'HyperGParams'
  designALL <- names(unlist(as.list(hgu133plus2ACCNUM)))
  entrezIds <- mget(designALL, envir = hgu133plus2ENTREZID)
  designKEGG <- names(entrezIds)[sapply(entrezIds, function(x) !is.na(x))]
  entrezUniverse <- unique(unlist(mget(designKEGG, hgu133plus2ENTREZID)))
  listKEGG <- intersect(probeList, designKEGG)
  selectedEntrezIds <- na.omit(unique(unlist(mget(listKEGG, hgu133plus2ENTREZID))))
  params.KEGG.over <-new("KEGGHyperGParams", geneIds=selectedEntrezIds, universeGeneIds=entrezUniverse, annotation = "hgu133plus2.db", pvalueCutoff = 0.05, testDirection="over")
  
  ## Hypergeometric test
  hgOver.KEGG <- hyperGTest(params.KEGG.over)

  ## Html report
  htmlresult(hgOver.KEGG, filename = "htmlreport.html")
}

\keyword{htest}
